// Copyright (c) 2010 Keith D Gregory, all rights reserved
package com.kdgregory.app.s3util;

import javax.swing.SwingUtilities;

import org.apache.commons.lang.StringUtils;

import com.kdgregory.app.s3util.dialogs.BucketDialogController;
import com.kdgregory.app.s3util.dialogs.PrefsDialogController;
import com.kdgregory.app.s3util.main.Concierge;
import com.kdgregory.app.s3util.main.ConfigBean;
import com.kdgregory.app.s3util.main.MainFrameController;
import com.kdgregory.app.s3util.s3ops.S3InitialLoadOp;


/**
 *  Entry point for the <em>S3Util</em> GUI.
 */
public class Main
{
    public static void main(String[] argv)
    throws Exception
    {
        final Concierge concierge = new Concierge(new ConfigBean());
        SwingUtilities.invokeAndWait(new Runnable()
        {
            public void run()
            {
                new MainFrameController(concierge).buildAndShow();

                if (!concierge.getConfig().isConfigComplete())
                    new PrefsDialogController(concierge).show();

                if (StringUtils.isBlank(concierge.getConfig().getAmazonBucketName()))
                    new BucketDialogController(concierge).show();
                else
                    new S3InitialLoadOp(concierge).start();
            }
        });
    }
}
