// Copyright (c) 2010 Keith D Gregory, all rights reserved
package com.kdgregory.app.s3util.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.kdgregory.app.s3util.main.Concierge;
import com.kdgregory.app.s3util.s3ops.S3DeleteBucketOp;


/**
 *  Initiates a bucket deletion, with appropriate warning messages.
 */
public class BucketDelete
extends AbstractAction
{
    private static final long serialVersionUID = 1L;

    private Log _logger = LogFactory.getLog(this.getClass());

    private Concierge _concierge;


    public BucketDelete(Concierge concierge)
    {
        super("Delete Current Bucket");
        _concierge = concierge;
        setEnabled(false);
    }


//----------------------------------------------------------------------------
//  ActionListener
//----------------------------------------------------------------------------

    public void actionPerformed(ActionEvent evt)
    {
        _logger.info("invoked");
        int confirm = JOptionPane.showConfirmDialog(
                            _concierge.getDialogOwner(),
                            "Deletes are irrevocable. Are you sure you want "
                                + "to do this?",
                            "Confirm Delete Bucket",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.WARNING_MESSAGE);
        if (confirm == JOptionPane.NO_OPTION)
            return;

        int confirm2 = JOptionPane.showConfirmDialog(
                            _concierge.getDialogOwner(),
                            "No, really, are you sure? This is a BUCKET delete!",
                            "Confirm Delete Bucket",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.WARNING_MESSAGE);
        if (confirm2 == JOptionPane.NO_OPTION)
            return;

        int confirm3 = JOptionPane.showConfirmDialog(
                            _concierge.getDialogOwner(),
                            "Last chance to say No!",
                            "Confirm Delete Bucket",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.WARNING_MESSAGE);
        if (confirm3 == JOptionPane.NO_OPTION)
            return;

        new S3DeleteBucketOp(_concierge).start();
    }
}

