// Copyright (c) 2010 Keith D Gregory, all rights reserved
package com.kdgregory.app.s3util.s3ops;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.kdgregory.app.s3util.dialogs.BucketDialogController;
import com.kdgregory.app.s3util.main.Concierge;


/**
 *  Deletes a bucket and everything it contains.
 */
public class S3DeleteBucketOp
extends AbstractS3Op<Object>
{
    private Log _logger = LogFactory.getLog(this.getClass());

    public S3DeleteBucketOp(Concierge concierge)
    {
        super(concierge, "Deleting bucket");
    }


//----------------------------------------------------------------------------
//  Operation
//----------------------------------------------------------------------------

    @Override
    protected Object performOperation()
    throws Exception
    {
        _logger.debug("starting request");
        getBucket().deleteCascade();
        _logger.debug("request complete");
        return null;
    }


    @Override
    protected void onSuccess(Object ignored)
    {
        getConcierge().getConfig().setAmazonBucketName("");
        getConcierge().getMainFrame().resetBucket();
        new BucketDialogController(getConcierge()).show();
    }
}