// Copyright (c) 2010 Keith D Gregory, all rights reserved
package com.kdgregory.app.s3util.s3ops;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.kdgregory.app.s3util.filelist.FileListTableModel;
import com.kdgregory.app.s3util.main.Concierge;


/**
 *  Refreshes the file list for a bucket, first ensuring that the bucket
 *  exists by attempting to create it (Amazon considers this a no-op if
 *  the bucket already exists).
 */
public class S3InitialLoadOp
extends S3RefreshOp
{
    private Log _logger = LogFactory.getLog(this.getClass());

    public S3InitialLoadOp(Concierge concierge)
    {
        super(concierge);
    }


//----------------------------------------------------------------------------
//  Operation
//----------------------------------------------------------------------------

    @Override
    protected FileListTableModel performOperation()
    throws Exception
    {
        _logger.debug("attempting to create bucket");
        getBucket().create();
        return super.performOperation();
    }
}
